<?php
/*
+--------------------------------------------------------------------------
|   CubeCart 4
|   ========================================
|	CubeCart is a registered trade mark of Devellion Limited
|   Copyright Devellion Limited 2006. All rights reserved.
|   Devellion Limited,
|   5 Bridge Street,
|   Bishops Stortford,
|   HERTFORDSHIRE.
|   CM23 2JU
|   UNITED KINGDOM
|   http://www.devellion.com
|	UK Private Limited Company No. 5323904
|   ========================================
|   Web: http://www.cubecart.com
|   Email: info (at) cubecart (dot) com
|	License Type: CubeCart is NOT Open Source Software and Limitations Apply 
|   Licence Info: http://www.cubecart.com/v4-software-license
+--------------------------------------------------------------------------
|	form.inc.php
|   ========================================
|	Quantum Gateway DB transparent engine
+--------------------------------------------------------------------------
*/
if (!defined('CC_INI_SET')) die("Access Denied");
if(detectSSL() == FALSE) die ("<strong>Critical Error:</strong> This page can ONLY be viewed under SSL!");

if($_GET['process']==1) {

	$transData['customer_id'] = $orderSum["customer_id"];
	$transData['order_id'] = $orderSum['cart_order_id'];
	$transData['amount'] = $orderSum['prod_total'];
	$transData['gateway'] = "Quantum tdbe";

	// first check card
	require("classes".CC_DS."validate".CC_DS."validateCard.php");
	
	$card = new validateCard();
	
	$cardNo			= trim($_POST["cardNumber"]);
	$issueNo		= false;
	$issueDate		= false; 
	$issueFormat	= 4; 
	$expireDate		= trim($_POST["expirationYear"]).str_pad(trim($_POST["expirationMonth"]), 2, '0', STR_PAD_LEFT);  
	$expireFormat	= 4; 
	if($module['reqCvv']==1) {
		$scReqd			= TRUE;
	} else {
		$scReqd			= FALSE;
	} 
	$securityCode	= trim($_POST["cvv"]);
	
	$card = $card->check($cardNo, 
						$issueNo, 
						$issueDate, 
						$issueFormat, 
						$expireDate, 
						$expireFormat, 
						$scReqd, 
						$securityCode);

	if($module['validation']==1 && $card['response']=="FAIL") {
		
		$errorMsg = "";
		
		foreach($card['error'] as $val) {
			$errorMsg .= $val."<br />";
		}
		
		$transData['trans_id'] = "";
		$transData['status'] = "Fail";
		$transData['notes'] = $errorMsg;

	} else {

		$debug = "<table border=\"0\" cellpadding=\"3\" width=\"600\">
			<tr>
				<td>
		
		
		<b>Quantum Gateway<br />
		Transparent db engine<br />
		<br />
		<strong>Debug Info:</strong>
		
				</td>
			</tr>
			<tr>
				<td>";
		
		$ERROR_RETRIES				= 2;				# Number of transactions to post if soft errors occur
		
		$quantum_url 	= "https://secure.quantumgateway.com/cgi/tqgwdbe.php";
		
		$quantum_values				= array (
			"gwlogin"				=> $module['gwlogin'],
			"RestrictKey"			=> $module['RestrictKey'],
			"invoice_num"			=> $orderSum['cart_order_id'],
			"Dsep"					=> "Pipe",
			"trans_method"			=> trim($_POST["trans_method"]),
			"FNAME"					=> trim($_POST["firstName"]),
			"LNAME"					=> trim($_POST["lastName"]),
			"BADDR1"				=> trim($_POST["addr1"]).' '.trim($_POST["addr2"]),
			"BCITY"					=> trim($_POST["city"]),
			"BZIP1"					=> trim($_POST["postalCode"]),
			"BCOUNTRY"				=> trim($_POST["country"]),
			"BCUST_EMAIL"			=> trim($_POST['emailAddress']),
			"invoice_description"	=> "Payment for order number ".$orderSum['cart_order_id'],
			"amount"				=> $orderSum['prod_total'],
			"customer_ip" 		=> get_ip_address());
			if ($_POST['trans_method'] == "CC") {
				$quantum_values['trans_type'] = $module['transtype'];
				$quantum_values['ccnum'] = trim($_POST["cardNumber"]);
				$quantum_values['ccmo']	= trim($_POST["expirationMonth"]);
				$quantum_values['ccyr'] = trim($_POST["expirationYear"]);
				if ($module['reqCvv'] == 1) {
					$quantum_values['CVV2'] = trim($_POST['cvv']);
				}
			} else {
				$quantum_values['EFTType'] = "WEB";
				$quantum_values['aba'] = trim($_POST['aba']);
				$quantum_values['checkacct'] = trim($_POST['checkacct']);
				$quantum_values['phone'] = trim($_POST["phone"]);
			}
		// look up county
		$quantum_values['BSTATE'] = trim($_POST["state"]);
	
		$fields = "";
		foreach( $quantum_values as $key => $value ) $fields .= $key."=" . urlencode( $value ) . "&";
		
		
		$debug .= "<hr />";
		///////////////////////////////////////////////////////////
		
		$debug .= "<b>01: Post the transaction (see the code for specific information):</b><br />";
		$agent = "Mozilla/5.0 (Windows; U; Windows NT 5.0; en-US; rv:1.4) Gecko/20030624 Netscape/7.1 (affgrabber)";
		
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL,$quantum_url);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, rtrim( $fields, "& " ));
		curl_setopt($ch, CURLOPT_UNRESTRICTED_AUTH, 1);
		curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_ANYSAFE);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_USERAGENT, $agent);
		if($config['proxy']==1) {
	  		curl_setopt ($ch, CURLOPT_PROXY, $config['proxyHost'].":".$config['proxyPort']); 
	  	}
		$resp = curl_exec($ch); //execute post and get results
		curl_close ($ch);
		
		$debug .= "<br />Posted Fields:<br />$fields<br /><hr />";
		///////////////////////////////////////////////////////////
		
		$debug .= "<b>02: Get post results:</b><br />";
		$debug .= $resp;
		$debug .= "<br />";
		
		$debug .= "<hr />";
		///////////////////////////////////////////////////////////
		
		$debug .= "03: Parse post results string into individual, meaningful segments<br />";
		$debug .= "<table cellpadding=\"5\" cellspacing=\"0\" border=\"1\">";
			$debug .= "<tr>";
		
		$thereturn = explode("|", $resp);
		$responseSequence = array('Transaction Status', 'Auth Code', 'Transaction ID', 'AVS Response', 'CVV2 Response', 'Maxmind Score', 'Decline Reason', 'Decline Error Number');
		if (count($thereturn) > 0) {
			for ($i=0; $i<count($thereturn); $i++) {
				$thereturn[$i] = str_replace('"', '', $thereturn[$i]);
			}
			$thereisresponse = "Y";
			for ($i=0; $i< count($thereturn); $i++) {
				$debug .= "<td>" . $responseSequence[$i] . ":</td><td>" . $thereturn[$i] . "</td>";
			}		
		} else {
			$thereisresponse = "N";
			if (strlen($resp) > 0) {
				$debug .= "<td>There was a response but probably the separator was not Pipe, or you are using the wrong Gateway Login and Password. Please check the response</td>";
			} else {
				$debug .= "<td>There was a problem trying to contact the Gateway</td>";
			}
		}
		$debug .= "</tr>";
		$debug .= "</table>";
		
		
		$debug .= "<hr />";
		$debug .= "There is response: $thereisresponse. Thereturn[0] ". $thereturn[0] . "<hr />";
		$testcards = array("4111111111111111", "5454545454545454");
		///////////////////////////////////////////////////////////
		if ($thereisresponse == "Y") {
			if ($thereturn[0] == "APPROVED") {
				
				$statusLog = "Approved: " . $module['transtype'];
				$order->orderStatus(3,$orderSum['cart_order_id']);
				$jumpTo = "index.php?_g=co&_a=confirmed&s=2";
				
				
				$errorMsg = "Card has been charged.";
				
			} else {
				$statusLog = "Declined";
				$errorMsg = $lang['gateway']['card_declined'];
				$errorMsg .= "<br />Decline error Code: " . $thereturn[7] . "- &quot;".$thereturn[6]."&quot;";
			}
			if (in_array($_POST['cardNumber'], $testcards)) {
					$errorMsg .= "<br />Note: A test card was used for this transaction";
			}
			$transactionId = $thereturn[2];
		
		} else {
			$statusLog = "Error";
			$errorMsg = $lang['gateway']['card_declined'];
			$transactionId ='';
		}
				
		///////////////////////////////////////////////////////////
	
		if(!empty($transactionId)) {
			$transData['trans_id'] = $transactionId;
		} else {
			$transData['trans_id'] = "N/A";
		}
		$transData['status'] = $statusLog;
		$transData['notes'] = $errorMsg;
		$order->storeTrans($transData);
		

		if($module['debug'] == 1 && isset($debug)) {
			$debug .= "<b>04: Done.</b><br /></td>
				</tr>
			</table>";
			echo $debug;
			//exit;
		} elseif(isset($jumpTo) && !empty($jumpTo)) {
			httpredir($jumpTo);
		}
		unset($debug);
	}
}


$formTemplate = new XTemplate ("modules".CC_DS."gateway".CC_DS.$_POST['gateway'].CC_DS."form.tpl",'',null,'main',true,$skipPath=TRUE);

if(isset($errorMsg)) {
	
	$formTemplate->assign("LANG_ERROR",$errorMsg);
	$formTemplate->parse("form.error");

}
	
$billingName = makeName($orderSum['name']);
$deliveryName = makeName($orderSum['name_d']);

$formTemplate->assign("VAL_AMOUNT_DUE",sprintf($lang['gateway']['amount_due'],priceformat($orderSum['prod_total'],true)));
$formTemplate->assign("VAL_FIRST_NAME",$billingName[2]);
$formTemplate->assign("VAL_LAST_NAME",$billingName[3]);
$formTemplate->assign("VAL_EMAIL_ADDRESS",$orderSum['email']);
$formTemplate->assign("VAL_ADD_1",$orderSum['add_1']);
$formTemplate->assign("VAL_ADD_2",$orderSum['add_2']);
$formTemplate->assign("VAL_CITY",$orderSum['town']);

$thebstate = $orderSum['county'];
$isoLookup = $db->select("SELECT abbrev FROM `".$glob['dbprefix']."cubecart_iso_counties`
WHERE `name` LIKE '%".strtolower($orderSum['county'])."%'");
if($isoLookup == TRUE){
	$thebstate = $isoLookup[0]['abbrev'];
}	
$formTemplate->assign("VAL_COUNTY",$thebstate);

$formTemplate->assign("VAL_POST_CODE",$orderSum['postcode']);


$countries = $db->select("SELECT id, iso, printable_name FROM ".$glob['dbprefix']."cubecart_iso_countries ORDER BY printable_name");
	
	for($i=0; $i<count($countries); $i++) {
				
		if($countries[$i]['id'] == $orderSum['country']) {
			$formTemplate->assign("COUNTRY_SELECTED","selected='selected'");
		} else {
			$formTemplate->assign("COUNTRY_SELECTED","");
		}
	
		$formTemplate->assign("VAL_COUNTRY_ISO",$countries[$i]['iso']);

		$countryName = "";
		$countryName = $countries[$i]['printable_name'];

		if(strlen($countryName)>20) {
			$countryName = substr($countryName,0,20)."&hellip;";
		}

		$formTemplate->assign("VAL_COUNTRY_NAME",$countryName);
		$formTemplate->parse("form.repeat_countries");
	}

	if($module['echeck']=='Y') {
		$formTemplate->assign("LANG_PAYBYCARD",$lang['gateway']['payByCard']);
		$formTemplate->assign("LANG_PAYBYECHECK","Pay By e-Check");
		$formTemplate->assign("LANG_CHKACCT","Checking Account Number");
		$formTemplate->assign("LANG_ABANUMBER","ABA/Routing Number");
		$formTemplate->assign("LANG_ECHECK_INFO_TITLE","Electronic Fund Transfer / e-Check");
		$formTemplate->assign("VAL_PHONE_NUMBER",$orderSum['phone']);
		$formTemplate->assign("LANG_PHONE_NUMBER",$lang['gateway']['lang_phone']);
		$formTemplate->parse("form.qgwscript");
		$formTemplate->parse("form.eftenabled");
		
	} else {
		$formTemplate->parse("form.ccenabled");
	}
	if($module['reqCvv']==1) {
		$formTemplate->assign("LANG_CVV",$lang['gateway']['security_code']);
		$formTemplate->parse("form.cvv");
	}
	$formTemplate->assign("LANG_CC_INFO_TITLE",$lang['gateway']['cc_info_title']);
	$formTemplate->assign("LANG_FIRST_NAME",$lang['gateway']['first_name']); 
	$formTemplate->assign("LANG_LAST_NAME",$lang['gateway']['last_name']); 
	//$formTemplate->assign("LANG_CARD_TYPE",$lang['gateway']['card_type']);
	$formTemplate->assign("LANG_CARD_NUMBER",$lang['gateway']['card_number']);
	

	$formTemplate->assign("LANG_EXPIRES",$lang['gateway']['expires']);
	$formTemplate->assign("LANG_MMYYYY",$lang['gateway']['mmyyyy']);
	$formTemplate->assign("LANG_SECURITY_CODE",$lang['gateway']['security_code']);
	$formTemplate->assign("LANG_CUST_INFO_TITLE",$lang['gateway']['customer_info']);
	$formTemplate->assign("LANG_EMAIL",$lang['gateway']['email']);
	$formTemplate->assign("LANG_ADDRESS",$lang['gateway']['address']);
	$formTemplate->assign("LANG_CITY",$lang['gateway']['city']);
	$formTemplate->assign("LANG_STATE",$lang['gateway']['state']);
	$formTemplate->assign("LANG_ZIPCODE",$lang['gateway']['zipcode']);
	$formTemplate->assign("LANG_COUNTRY",$lang['gateway']['country']);
	$formTemplate->assign("LANG_OPTIONAL",$lang['gateway']['optional']);
	
	$formTemplate->assign("VAL_GATEWAY",sanitizeVar($_POST['gateway']));


$formTemplate->parse("form");
$formTemplate = $formTemplate->text("form");
?>